
                      NBMC: Navigator BookMark Customizer
                      ===================================
                 Version 3.0 for Netscape Navigator 2.x/3.x/4.x
                         (c) F. Pacquier - April 1998

==============================================================================
 Table Of Contents:
==============================================================================

 1 - What's it for ?
 2 - (How) does it work ? What's new in 3.0 ?
 3 - Step-by-step installation
 4 - Known issues and limitations, possible improvements
 5 - About the author
 6 - Famous last words, and a special rabbit...

 APPENDIX A - NBMC configuration file details

 APPENDIX B - NBMC.BAT commented code

 APPENDIX C - AUTOLINK.BAT commented code

 APPENDIX D - How to use NBMC with Microsoft Internet Explorer

 APPENDIX E - History

==============================================================================
 1 - What's it for ?
==============================================================================

 It's for customizing Netscape Navigator bookmarks :-)

 Seriously, now, here's why I created this utility:

 Netscape stores its bookmarks in HTML format. When you use Add Bookmark and 
 the Bookmark Editor to create the entries and submenus in the Bookmark menu, 
 everything is saved in a file called bookmark.htm in the Netscape Navigator
 directory.

 I use this file as my Home Page --ie, in my General Preferences, my home 
 page URL is something like "file:///C|/Netscape/Navigator/Bookmark.htm".
 Thus, when I launch Netscape or press the Home button, my bookmarks get 
 displayed in the browser window instead of Netscape's site or whatever, and 
 I don't have to use the Bookmark menu to surf around.

 The only problem is, Netscape has its own HTML layout to store your 
 bookmarks in. It's not particularly pretty, and it's not very compact: even 
 if you try to keep your bookmark list tidy, the resulting page can easily 
 scroll through a few screens, which is uncool. And you can't customize your 
 bookmark.htm, because it's overwritten every time you add or edit bookmarks 
 from the menu.

 What I wanted was something to generate a customized home page from the 
 bookmark file, showing all my links on more or less one screen, in whatever
 flashy layout I fancied. Of course I needed a quick way to update this page 
 after adding, deleting or editing links, and maybe switching between 
 different layouts depending on my mood. This is what NBMC does.
 
 If you still don't quite see what I mean, maybe the best way is to go to my 
 Web page (providing it still works) and see the examples I've set up there 
 to illustrate how NBMC works (see Section #6 below).

 
==============================================================================
 2 - (How) does it work ? What's new in 3.0 ?
==============================================================================

 Let me say it right now before you find out:
 It's a quick hack, it's downright ugly, and it works well enough.
 And it beats trying to learn C++ just for that :)

 NBMC is a combination of a DOS batch file, a search & replace utility called 
 GSAR, one or more configuration files... and Netscape Navigator.

 GSAR is a freely distributable package I found on the Net. For simplicity's 
 sake (& size) I have included only the executable, man page and GNU license 
 agreement. The complete package (with sources) is available with the latest
 version of NBMC on my home page (if it works), or at Garbo or any of its 
 mirrors.

 So this is how it goes: the batch file filters Netscape's bookmark.htm and 
 writes a temp file containing only the HTML statements concerning submenus 
 and links (ie, <H3> and <A> tags).
 From the first section in the configuration file (passed as a parameter to
 the batch) an auxiliary batch file is created, that contains all the GSAR
 search & replace commands that have been specified to massage the HTML
 code for your bookmarks. This auxiliary batch is run on the temp file just
 created and generates the body for your new bookmark file (nbmc.htm).
 Then, the second and third sections of the configuration file are also
 filtered and prepended or appended, respectively, to the new nbmc.htm so
 that you can also customize the header and footer of the file and add any 
 relevant statements there automatically.

 That's the bulk of it. It is in fact a bit more complicated than that, 
 because I wanted to make configuration files as easy to understand, read 
 and maintain as possible for the user. So the search & replace commands you 
 define in the configuration file use a very easy syntax; GSAR itself is run 
 once on those lines to translate them to actual GSAR commands for the 
 auxiliary batch file. These commands are more arcane mostly because HTML 
 uses a lot of signs like spaces, <, and > that have to be converted to 
 ASCII codes before being passed as parameters. This way, the user never has 
 to bother with this.
  
 Appendix A shows a heavily commented configuration file, with syntax, 
 caveats, hints, etc. It is actually the same as the CONFIG1.BMC sample file 
 in the package. Its size may seem daunting due to the amount of comments, 
 but if you look at the other four sample files (CONFIG2-5.BMC) which have 
 the comments stripped out, you will find that there actually is little meat 
 and very few things to change to make your own customizations.

 You can have as many config files as you wish, by any name you wish, 
 provided the extension is .BMC (see why below). Run the batch with a config 
 file's name as a parameter (together with extension, see why below) and your 
 plain old bookmark.htm gets a new look each time...

 Now the final straw:
 You can include links to your config files in the generated home page. In 
 Netscape, set up NBMC as a helper app associated with .BMC files, and a 
 click on such a link will recreate said home page according to that 
 particular config file. I still can't believe it myself.

 Version 3 introduces a new feature, "autolinks". If the new {autolinks} tag
 appears in the {head} and/or {tail} sections of your configuration file,
 the resulting NBMC.HTM will be further processed by AUTOLINK.BAT. Any such
 tag will be replaced by a menu of links to each and every configuration file
 present in your NBMC directory, so you don't have to code the links by hand
 in your configuration files anymore... Moreover, if your configuration files
 use the new {desc} tag to provide a description string, that string will be
 used as the text of the link instead of the file name itself, making for
 more meaningful link menus (just remember to keep your description strings
 short enough with NO spaces or DOS special characters like < > | \ etc...).
 Within the menu, the link to the configuration file being used to generate
 the page will be highlighted, so the page can easily invoke NBMC to update
 itself.

 If you're interested in how things work, Appendix B has a commented version
 of NBMC.BAT (the actual program has no comments to speed things up). Among 
 others things it shows how to make a very small change to achieve non-
 case-sensitive search & replace if you ever need it. You might think of 
 other improvements, too.

 Appendix C is a similarly commented version of AUTOLINK.BAT; It also shows
 how and where you can customize the way links are separated in the menu,
 and the way the current configuration's link is highlighted.


==============================================================================
 3 - Step-by-step installation:
==============================================================================

 Even if you get the general idea from my lousy explanations (and especially 
 if you don't), it's good to follow this checklist to make sure all the 
 grousy little details are taken care of:

 Step 1:
 ------
 First, locate the directory on your disk that holds the file BOOKMARK.HTM.
 For Netscape versions 2.x and 3.x, this would the "Navigator" directory
 (ie something like C:\Program Files\Netscape\Navigator).
 Starting with versions 4.x, Communicator supports several users on the same 
 computer. Thus you should have a "Users" directory under "Netscape", with a 
 subdirectory like your email address or whatever you chose during setup, 
 for example: C:\Program Files\Netscape\Users\fredp.
 Create a subdirectory named NBMC (or whatever) _right under_ this directory 
 (the one where Bookmark.htm is). This is mandatory, as it keeps absolute
 path references to a bare minimum, making things more 'portable'.

 Step 2:
 ------
 Dump the entire NBMC.ZIP content in that directory and switch to it.

 IMPORTANT NOTE:
 ==============
 If you're upgrading from NBMC 2, watch out for your own custom configuration
 files ! If they're named Config1.bmc to Config5.bmc they might get overwritten
 with the samples provided in the archive !

 Step 3:
 ------
 Run nbmc.bat with one of the sample config files provided (as in, for 
 instance, 'nbmc config1.bmc'). The batch will only run if it finds itself in 
 the current directory, along with some .bmc files in general and the one you 
 specified in particular, _and_ a bookmark.htm file in the parent dir. Whew.
 And oh, yeah, it also wants GSAR.EXE right alongside, too...
 Version 3 also checks for AUTOLINKS.BAT, whether you use the feature or not.
 If everything goes well (and why not?) a nbmc.htm is created.

 Step 4:
 ------
 Create a NBMC.PIF file in this same directory (with pifedit in Windows3, 
 a shortcut in Windows 95). Set it to run NBMC.BAT and _specify the working 
 directory_ to the nbmc dir, as well as _close on exit_. You will probably 
 want it to run in a window rather than full-screen, but maybe you should 
 not run it minimized until you are sure everything is OK (ie after step 7).

 Step 5:
 ------
 Run Netscape. Use Open File to load nbmc.htm from its directory (never 
 mind if you hate the results ! :-).
 Netscape 2.x/3.x: select the URL in the location window and copy it (control-C). 
 Now go to General Preferences and paste it in the Home Page location (with control-V).

 Netscape 4.x: Use Edit/Preferences menu, select the 'Navigator' category, 
 and press the "Use Current Page" button.

 Step 6:
 ------
 Netscape 2.x/3.x:
 Still in General Preferences, go to the Helpers tab. 
 Press the "Create New type" button.

 Type in something sensible like:
         Mime Type   : application
         Mime subType: nbmc
 This new entry now needs two things:
  - An associated extension -- type BMC
  - An associated action -- check the Launch radio button 
                            then browse to NBMC.PIF 
    (make sure the result really is nbmc.pif, not nbmc.bat -- sometimes 
     Windows95 gets it wrong).

 Netscape 4.x:
 Use Edit/Preferences menu, open the 'Navigator' category, 
 select "Applications".
 Press the "New Type" button.

 Fill in the fields:
 Description of type: NBMC Configuration File
 File extension: BMC
 MIME Type: application/nbmc
 Application to use:
 Hit the 'Browse' button. Navigate to the NBMC directory.
 There you will have to manually type "NBMC.PIF" in the "Name"
 box, because silly Netscape will not list shortcuts. Click 'OK'.
 Now scroll to the end of the newly filled field and you will find that
 silly Netscape has changed the extension from .PIF to .BAT !
 Change it back to .PIF, add a space, then "%1" at the end...
 Click 'OK'. Whew ! Talk about simplification...
 To save you grief, now that the new NBMC type is created, you
 might want to click on 'Edit' and uncheck the box:
 'Ask me before opening downloaded files of this types'...

 Step 7:
 ------
 Now back to the home page -- click on one of the five links at the 
 bottom, pointing to config1.bmc through config5.bmc. You should see 
 Netscape invoke the helper app and run the batch in a window with the 
 corresponding config file as a parameter.
 Then hit 'Reload', and you should have a brand new home page...
 Notice that the current configuration name's link is between parentheses.

 Step 8:
 ------
 If all is well, now is the time to start tinkering with your own config 
 files to customize your own layouts. It's a fun way to learn basic HTML if 
 you don't already have. Examine the sample files until you understand why 
 they're made that way, what to edit and what to leave alone.

 Two things to keep in mind:

 a) you can't break anything, and certainly not your original bookmark file, 
 so go ahead and experiment ;

 b) there are only three absolute path references to the NBMC directory in 
 the whole system: one for the Netscape Home Page, one for the Netscape 
 Helper App, and one inside NBMC.PIF. None inside NBMC.BAT, and none inside 
 the configuration files. You should probably try to keep it that way !

 
==============================================================================
 4 - Known issues and limitations, possible improvements:
==============================================================================

 * under Windows 95, you may have to manually type in the .PIF 
   extension when specifying NBMC as the helper app. Dunno why.

 * if you regenerate your nbmc.htm home page too soon after editing 
   your bookmarks, the bookmark file may still be in the disk cache, with 
   Bookmark.htm on disk (and thus nbmc.htm) not reflecting the changes.

 * you still have to manually reload the page after refreshing it. I would 
   like to have it done automatically. I would also like to have graphics 
   painted on startup even if 'Autoload images' is off. If anyone knows how
   to do this, mail me...

 * I have only tested this with Netscape Navigator 2.02 and 3.0 (16 and 32 bit 
   versions), Communicator 4.x under Windows 95, and my bookmarks only have 
   one level of menus. YMMV.
   
 * I have not personally tested NBMC with Windows NT Workstation and Microsoft
   Internet Explorer, although users have reported both do work with version 2.
   Tweaks to version 2 have been incorporated in version 3 to ensure Windows NT
   compatibility, and standalone MSIE users can take advantage of NBMC with 
   a bit of work although I no longer support this (see Appendix D).
   
 * barring any bugfix releases, sudden strokes of genius in my sleep, or
   irresistible ideas submitted by fanatical users, this will be the last
   iteration of NBMC. DOS batch files are _very_ hard to maintain and
   evolve, NBMC suits my needs as it is now, and I'm out of steam :-)

 
==============================================================================
 5 - About the author:
==============================================================================

 I live in Paris, I'm no programmer, I love Quake deathmatches and I can't 
 write dox (not even in French :-)

 At the time of this writing, my email address is:
    fredp@mygale.org

 and my home page for NBMC stuff is:
     http://www.mygale.org/~fredp/
 
 Unfortunately, the Internet being in the state it is (especially in 
 France :), both are liable to change without notice.
 
 If you really want to contact me, and none of the above work, go to 
 Alta Vista and search Usenet for Fred Pacquier. You'll find me <g>.

 
==============================================================================
 6 - Famous last words, and a special rabbit...
==============================================================================

 Version 3.0 is dedicated to: B.K. in Staten Island, New York,
 ...my very special NBMC user -- the only woman I know of, with three children 
 _and_ 18 (EIGHTEEN) custom configurations at last count ! :-)
 Without her, this release would probably have stayed under wraps, so kudos 
 to you, "rabbit1" !

 CONFIG4.BMC was contributed by Charles Gillen, thanks to him.

 NBMC is free and you get what you pay for. It works for me. If it doesn't 
 for you, fix it or can it. Send me praise. Send flames to AOL.
 
 ...Above all, Enjoy ! :-)


==============================================================================
                   APPENDIX A - NBMC configuration file details
==============================================================================

:: This is the same as the CONFIG1.BMC sample in the original package
:: 
:: NBMC 3.0 sample configuration file -- (c) F. Pacquier 1998
:: (lines starting with ':: ' are comments and ignored by NBMC.BAT)
:: 
:: Section 1
:: 
:: This section holds the search & replace instructions
:: 
:: These will be parsed and used by GSAR to read the headers and bookmarks
:: from your original BOOKMARK.HTM file and generate the body of your
:: custom NBMC.HTM file.
:: 
:: Each line must follow the syntax:
:: 
:: from{string1}to{string2}
:: 
:: 
:: Things To Be Careful Of:
:: =======================
:: 
:: * WHITESPACE is SIGNIFICANT in string1 and string2 ! 
::   string2 may be empty if you just want to remove string1 completely
::   (see first uncommented search & replace line below)
:: 
:: * Everything is CASE SENSITIVE by default
::   (this can be changed and is documented in NBMC.MAN)
:: 
:: * NO TRAILING SPACES after the last '}' at the end of each line...
:: 
:: * Special characters can be specified using the :ddd notation, where
::   ddd is the 3-digit decimal ASCII code for the character. Add a zero
::   if necessary. For instance, if you need a '|' (pipe) char in string1
::   or string2, use ':124'. A DOS end-of-line pair is ':013:010'.
::   If you need a plain ':' use '::'. (This is GSAR syntax).
:: 
:: * KEEP LINES SHORT ! These instructions will be parsed by GSAR to
::   produce GSAR commands that will in turn parse NBMC.TMP. In doing this,
::   special chars like spaces, <, > will be turned into :ddd notation, and
::   from{...}to{...} tokens will be turned into GSAR commands and options.
:: 
::   For instance, the instruction:
:: 
::    from{< A >}to{<a>}
:: 
::   would be executed as the DOS command:
:: 
::    gsar -s:060:032A:032:062  -r:060a:062 -o nbmc_htm.tmp>NUL
:: 
::   As expanded commands will typically be quite longer than the original
::   instructions, these must be kept short to avoid running into the DOS
::   command length limitation...
:: 
::   To achieve this you can spread your substitutions over several passes,
::   as in the examples below. First suppress all unwanted material; then
::   substitute existing tags or insert new ones. You can use shorthand
::   (like '^' for return/linefeed and <dot.blue> for an image anchor) for
::   frequently repeated stuff and then expand these in turn at the end.
::   This also makes the substitution code easier to read and to maintain.
:: 
::   Note: instructions are executed in the order they appear here, with
::   additional expansion to GSAR command lines at the very end.
:: 

from{  }to{}
from{<DT>}to{}
from{FOLDED }to{}
from{<H3}to{<HR>^<dot.blue>^<B}
from{/H3>}to{/B>^<dot.blue>}
from{/A>}to{/A>^<dot.gray>}
from{^}to{:013:010}
from{<dot.blue>}to{<img alt="" src="dot_blue.gif" hspace=5>}
from{<dot.gray>}to{<img alt="" src="dot_gray.gif" hspace=0>}


:: 
:: Section 2
:: 
:: This section is used to store additional HTML statements 
:: 
:: These lines will be inserted at the beginning of nbmc.htm
:: 
:: They will be added by nbmc.bat using a FIND on the tag string {head}
:: so edit at will & add as many as you want but make sure each line
:: starts with the tag string !
::

{head}<html>
{head}<head>
{head}<title>NBMC Custom BookMarks</title>
{head}</head>
{head}<body background="bg_moon.jpg" link="#FF0000" vlink="#2F4F2F" alink="#000000">
{head}<center>


:: 
:: Section 3
:: 
:: This section is used to store additional HTML statements 
:: 
:: These lines will be appended to nbmc.htm
:: 
:: They will be added by nbmc.bat using a FIND on the tag string {tail}
:: so edit at will & add as many as you want but make sure each line
:: starts with the tag string !
::
:: Note the use of the {autolink} tag, new to NBMC 3.0. If it appears in a
:: configuration file (in the head, tail or both), NBMC will first create
:: the NBMC.HTM file, then process any {autolinks} tags in it as follows : 
::
:: - look for all *.BMC configuration files in the NBMC directory
:: - look for a {desc} tag in each configuration file; if none use file name
:: - concatenate these description or file names in a string, using a
::   separator character or string
:: - turn each description or file name into a link to the corresponding
::   configuration file
:: - highlight the description or name of the current configuration
:: - replace any {autolink} tags by the resulting string
::
:: Of course, additional text and/or HTML tags can appear before and after
:: the {autolink} for placing/formatting on a per-configuration basis, as
:: in the example below. However, the separator between links and the method
:: for highlighting the current configuration can only be customized in the
:: batch file, and will thus be the same across all configurations (the
:: default separator is &#183; and the default highlight method is putting
:: the name between parentheses)

{tail}<hr><font size=-1><i>
{tail}Generate configuration :
{tail}{autolinks}
{tail}</i></font></center>
{tail}</body>
{tail}</html>

:: 
:: Section 4
:: 
:: This is not really a section, just a tag that was added for the
:: "autolinks" feature in version 3. It can actually appear anywhere
:: in a configuration file (although only once). If it is present and
:: "autolinks" is used (by this config file or another) to generate
:: links to all existing config files in NBMC.HTM, the link to this
:: particular config will appear as the text following this tag instead
:: of the config file name.
:: In this case the link would appear as 'Compact' instead of 'CONFIG1'.
:: 

{desc}Compact


:: 
:: End of config file.
:: 


==============================================================================
                        APPENDIX B - NBMC.BAT commented code
==============================================================================

@echo off
:: 
:: All these conditions must be met before NBMC.BAT will run:
:: 
:: Current dir must be subdirectory of original Netscape BOOKMARK.HTM 
if not exist ..\bookmark.htm goto error1

:: Current dir must contain NBMC.BAT itself
if not exist nbmc.bat        goto error2

:: In version 3 current dir must contain AUTOLINK.BAT
if not exist autolink.bat    goto error2bis

:: GSAR.EXE must also be in current directory (not needed in PATH)
if not exist gsar.exe        goto error3

:: at least one configuration file must be present
if not exist *.bmc           goto error4

:: if no parm passed print usage & available configs
if (%1)==()                  goto usage

:: if parm passed assume it is a config file & test if present
if not exist %1              goto error5

:: create a temp file in current directory from BOOKMARK.HTM in parent dir
:: containing only header & anchor tags (ie menus titles & links),
:: stripped of all other HTML formatting information
::
echo. nbmc: running version 3.0
echo. nbmc: parsing Netscape bookmark file for header and link tags
 type  ..\bookmark.htm | find "ADD_DATE" > nbmc_htm.tmp

:: now we create an auxiliary batch file by running GSAR on the 'search
:: and replace' section of the configuration file passed as a parameter.
:: The concise and easy-to-read instructions from the config file are
:: translated to absconse GSAR DOS command lines, compliant with GSAR syntax
:: and characters significant to COMMMAND.COM like <, > and spaces.
:: 
echo. nbmc: creating auxiliary batch file

:: create the temp batch file from the first section of the config file,
:: without comment lines. The triple find is probably overkill, just to
:: stay on the safe side...
:: In version 3 the batch name has been changed to nbmc_sar.bat to avoid
:: problems caused by the ampersand in Windows NT DOS boxes.
:: 
 type %1 | find "from{" | find "}to{" | find /v ":: " > nbmc_sar.bat

:: this changes all '<' chars in the batch to their GSAR ':060' equivalent
 gsar  -s:060       -r::060                           -o nbmc_sar.bat >NUL

:: this changes all '>' chars in the batch to their GSAR ':062' equivalent
 gsar  -s:062       -r::062                           -o nbmc_sar.bat >NUL

:: this changes all spaces in the batch to their GSAR ':032' equivalent
 gsar  -s:032       -r::032                           -o nbmc_sar.bat >NUL

:: this replaces 'from{' with 'gsar -s', creating the command lines
:: NOTE:
:: if you want the s&r instructions in your configuration files to be
:: case-insensitive, you should replace this line with the following:
:: gsar  -sfrom{      -rgsar:032-i:032-s              -o nbmc_sar.bat >NUL
 gsar  -sfrom{      -rgsar:032-s                      -o nbmc_sar.bat >NUL

:: this replaces '}to{' with ' -s'
 gsar  -s}to{       -r:032-r                          -o nbmc_sar.bat >NUL

:: this replaces the trailing '}' with ' -o nbmc_htm.tmp'
 gsar  -s}:013:010  -r:032-o:032nbmc_htm.tmp:013:010  -o nbmc_sar.bat >NUL

:: this adds '>NUL' to the end of the command line for silent operation
:: NOTE:
:: if your original s&r instruction is a bit long and the expanded command
:: line nears the DOS limit, you can safely comment out this line to
:: gain a few characters
 gsar  -smp:013:010 -rmp:062NUL:013:010               -o nbmc_sar.bat >NUL

:: now we run the newly created auxiliary batch file against the temp file
:: created from BOOKMARK.HTM, to generate the new HTML formatting for your
:: menu titles and links
echo. nbmc: substituting HTML tags from Bookmark.htm to NBMC.HTM
 call nbmc_sar.bat

:: finally we create the NBMC.HTM file that will be used as your Netscape
:: home page, by combining the second section of the configuration file,
:: the temp file as generated above, and the third section of the config:
echo. nbmc: writing NBMC.HTM head & tail
:: get the uncommented lines from section 2 of config files and initialize
:: nbmc.htm with them
 type %1 | find "{head}"  | find /v ":: "  > nbmc.htm
:: append the modified HTML body generated by GSAR
 type nbmc_htm.tmp                        >> nbmc.htm
:: get the uncommented lines from section 3 of config files append them
 type %1 | find "{tail}"  | find /v ":: " >> nbmc.htm
:: use GSAR again to remove the {head} and {tail} tags from nbmc.htm
 gsar  -s{head}  -r  -o nbmc.htm  > NUL
 gsar  -s{tail}  -r  -o nbmc.htm  > NUL

:: The only real addition to NBMC.BAT in version 3: after its job is
:: done, before exiting the batch invokes AUTOLINK.BAT with the
:: "-checktags" argument to see if the newly generated NBMC.HTM
:: contains any {autolinks} tag(s). If so, AUTOLINK will take care
:: of the rest...
:: 
echo. nbmc: running AUTOLINK.BAT
 call autolink.bat -checktags  %1

:: housekeeping
:: NOTE:
:: if you have problems with NBMC's output or want to trace or otherwise
:: modify the way it works, comment out these lines so you can run the
:: batch and see the working files being generated
echo. nbmc: cleaning up
 del *.tmp
 del nbmc_sar.bat

echo. nbmc: done.

goto end

:usage
echo. 
echo. nbmc: Navigator BookMark Customizer
echo.       Version 3.0 for Netscape Navigator
echo.       (c) Fred Pacquier - April 1998
echo. 
echo. Usage: nbmc config.bmc
echo. 
echo. Action: reads bookmark.htm in parent directory and generates nbmc.htm
echo. in current directory according to directives in config.bmc
echo. 
echo. Available configuration files are:
dir /-p/w *.bmc | find /i ".BMC"
echo. 
goto end

:error1
echo. nbmc error: BOOKMARK.HTM not in parent directory -- aborted.
goto end

:error2
echo. nbmc error: NBMC.BAT not in current directory -- aborted.
goto end

:error2bis
echo. nbmc error: AUTOLINK.BAT not in current directory -- aborted.
goto end

:error3
echo. nbmc error: GSAR.EXE not in current directory -- aborted.
goto end

:error4
echo. nbmc error: no .BMC config files in current directory -- aborted.
goto end

:error5
echo. nbmc error: %1 not found in current directory -- aborted.
goto end

:end

==============================================================================
                      APPENDIX C - AUTOLINK.BAT commented code
==============================================================================

@echo off

::::::::::::::::::::::
:: dispatch section ::
::::::::::::::::::::::

:: 
:: NOTE:
:: This batch file could have been (and was!) much more concise,
:: and also totally unreadable (meaning, more totally than now)...
:: The current structure is admittedly overkill, but it is an
:: attempt to make it easier to understand and maintain for 
:: regular humans, including me in a few days' time...
:: 

:: First, test if AUTOLINK.BAT is being called by NBMC.BAT or itself
:: (NBMC_SAR.BAT is a temp auxiliary file created by NBMC.BAT
::  before it calls AUTOLINK.BAT and deleted after the call returns)
:: 
if not exist nbmc_sar.bat goto err_msg

:: If first parameter is "-checktags" then AUTOLINK.BAT is being called by
:: NBMC.BAT to see if any {updatelink} tag(s) need(s) processing
:: in the NBMC.HTM just generated by NBMC.BAT
:: 
if %1)==-checktags) goto check_tags

:: If first parameter is "-autolinks" then AUTOLINK.BAT is being called by
:: itself to process an {autolinks} tag in NBMC.HTM during the
:: "check_tags" process (see relevant section below)
:: 
if %1)==-autolinks) goto auto_links

:: If first parameter is "-addlink" then AUTOLINK.BAT is being called by
:: itself to process an individual configuration file during the
:: "auto_links" process (see relevant section below)
:: 
if %1)==-addlink) goto add_link


::::::::::::::::::::::::
:: check_tags section ::
::::::::::::::::::::::::

:check_tags

echo. autolink: running version 1.0

:: This section is executed first when AUTOLINKS is called
:: by NBMC.BAT. Here we test for the presence of one or
:: more {autolinks} tags in NBMC.HTM, using well-
:: known old DOS batch tricks (that are documented in code
:: section below if you've never seen them).
:: Upon finding one or more of these tags AUTOLINK invokes itself
:: with the '-autolink' switch for processing of the tag by
:: the corresponding code section.
:: Note that nothing here prevents you from having the tag
:: appear several times in the layout, on top and bottom
:: of page for instance.
:: 

echo. autolink: checking for {autolinks} tag(s) in NBMC.HTM
 type %2 | find "{autolinks}" | find /v ":: " > al_test1.tmp
 copy al_test1.tmp al_test2.tmp >NUL
 if exist al_test2.tmp call autolink -autolinks %2

echo. autolink: done.
goto end


::::::::::::::::::::::
:: add_link section ::
::::::::::::::::::::::

:add_link

echo. autolink: adding link to configuration file %2
 
:: This code section is called once from "auto_links"
:: for each configuration file in the NBMC directory.
:: %1 is '-addlink', %2 is the file name.
:: 
:: First we need to determine if that configuration file contains
:: a description (ie, a non-commented {desc} tag followed by text)
:: 
 del *.tmp
 type %2 | find "{desc}" | find /v ":: " > confdesc.tmp
 copy confdesc.tmp linkname.tmp >NUL

:: If there was a description then confdesc.tmp is not empty
:: so it is copied over to linkname.tmp and we proceed to :skip1
:: 
 if exist linkname.tmp goto skip1
 
:: If there was no description, confdesk.tmp is empty:
:: DOS does not copy empty files so linkname.tmp does not
:: exist. Here we create one using the file name passed as
:: a parameter, then removing the .BMC extension
:: 
    echo %2> linkname.tmp
    gsar -i -s.bmc -r -o linkname.tmp >NUL

:skip1

:: remove the {desc} tag, if present
:: 
 gsar -s{desc}   -r  -o linkname.tmp >NUL

:: The next few lines do the actual job. Using the description
:: in linkname.tmp and GSAR commands, we create a batch file
:: named ADD_LINK.BAT that itself is a GSAR command. Its goal
:: is to find an {autolinks} tag in NBMC.HTM and replace it with
:: a link to the configuration file displaying its description, 
:: followed by a {sep} tag, a newline and an {autolinks} tag.
:: The original {autolinks} becomes something like:
:: 
:: <A HREF="filename.bmc">description</A>{sep}
:: {autolinks}
:: 
:: The ADD_LINK.BAT file itself looks something like:
:: gsar -s{autolinks} -r:060a:032href="%2":062description:060/a:062{sep}:013:010{autolinks} -o nbmc.htm>NUL
:: 
:: ...so, **again** :
:: ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: Keep descriptions short, with no spaces or DOS reserved characters!
:: ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 
 echo gsar -s{autolinks} -r:060a:032href="%2":062> add_link.bat
 gsar -s:013:010 -r  -o add_link.bat >NUL
 type linkname.tmp >> add_link.bat
 gsar -s:013:010  -r::060/a::062{sep}::013::010{autolinks}:032-o:032nbmc.htm  -o add_link.bat >NUL
 gsar -s.htm      -r.htm:062NUL:013:010                                       -o add_link.bat >NUL
 call add_link.bat

goto end


::::::::::::::::::::::::
:: auto_links section ::
::::::::::::::::::::::::

:auto_links

echo. autolink: creating automatic configuration menu

:: For each configuration file in the NBMC directory, AUTOLINK calls
:: itself with "-addlink" as the first parameter and the file name as
:: the second. See "add_link" section above.
:: Note: this means that links in the configuration menu will appear in
:: the same order as the files in the directory would in an unsorted DIR.
:: 
 for %%f in (*.bmc) do call autolink -addlink  %%f

:: Arriving here means that AUTOLINK has already processed all configuration
:: files one by one by calling itself repeatedly as above. The original
:: {autolinks} tag in NBMC.HTM has now been replaced by several lines
:: containing the description (or filename) of the configuration files,
:: each linked to the actual file and followed by a {sep} tag, as in:
:: <A HREF="filename.bmc">description</A>{sep}
:: There is a trailing {autolinks} tag following these lines.
:: 

echo. autolink: inserting link separators
 
:: Remove the trailing separator and autolinks tags
:: 
 gsar -s{sep}:013:010{autolinks}  -r        -o nbmc.htm >NUL
 
:: Replace the separator tags by some adequate string
:: the default of "&#183;" can be user-customized below
:: 
 gsar -s{sep}                     -r&#183;  -o nbmc.htm  >NUL

:: The rest of this section is mostly devoted to finding the link
:: in the menu that points to the configuration file currently
:: being used to generate NBMC.HTM, ie the parameter passed to
:: NBMC.BAT, and highlighting it in some way or other.
:: (Note: NBMC.BAT passes its first parameter as AUTOLINK.BAT's
::  second as it invokes it. AUTOLINK.BAT does not check for this).
:: 
echo. autolink: highlighting current configuration
 
:: Same trick as in the "add_link" section above, a bit modified:
:: We check for the presence of a description in the configuration
:: file by filtering, copying the result to another file and
:: checking if that file exists. Only here, we output the
:: '{desc} tag/description text' pair TWICE to the auxiliary file
:: CURRLINK.BAT to make the GSAR command generation easier.
:: 
 type %2 | find "{desc}" | find /v ":: " > confdesc.tmp
 copy /b confdesc.tmp+confdesc.tmp currlink.bat >NUL

 if exist currlink.bat goto skip2

:: If we are here then there was no description in the configuration
:: file, the output was empty and the 0-length file was not copied.
:: We then create our own using the file name as a description,
:: adding a {desc} tag and doing it twice to make the output
:: similar to the previous case. We then remove the .BMC extension.
:: 
    echo {desc}%1> currlink.bat
    echo {desc}%1>> currlink.bat
    gsar -i -s.bmc -r -o currlink.bat >NUL

:skip2
 
:: The resulting output has two lines and two {desc} tags. Here we
:: invert the second {desc} tag to {csed} and remove the middle cr/lf
:: so that only one line is left, of the form: {desc}text{csed}text
:: 
 gsar -s:013:010{desc} -r{csed} -o currlink.bat >NUL
 
:: In the following lines, the line {desc}text{csed}text becomes:
:: gsar -i -s:062text:060 -r:062{curr}text{/curr}:060 -o nbmc.htm>NUL
:: 
:: In other words, when this command is run as CURRLINK.BAT, the
:: string(s) '>text<' will be changed to '>{curr}text{/curr}<' in
:: NBMC.HTM. This is the description of the link to the current
:: configuration file; by giving values to {curr} and {/curr} we can
:: decide how we want it highlighted.
:: 
 gsar -s{desc}    -rgsar:032-i:032-s::062                   -o currlink.bat >NUL
 gsar -s{csed}    -r::060:032-r::062{curr}                  -o currlink.bat >NUL
 gsar -s:013:010  -r{/curr}::060:032-o:032nbmc.htm:013:010  -o currlink.bat >NUL
 gsar -s.htm      -r.htm:062NUL                             -o currlink.bat >NUL
 
:: Here we replace {curr} and {/curr} by meaningful strings to
:: highlight the link. This extra step is only here to make it
:: easier for users to customize the link menu's appearance.
:: 
 gsar -s{curr}    -r(                                       -o currlink.bat >NUL
 gsar -s{/curr}   -r)                                       -o currlink.bat >NUL

:: For instance, if you prefer having the text in bold type instead
:: of between parentheses, you could comment out the two lines above
:: and uncomment in the two following:
:: 
::  gsar -s{curr}    -r:060b:062                            -o currlink.bat >NUL
::  gsar -s{/curr}   -r:060/b:062                           -o currlink.bat >NUL

:: do the substitutions, clean up, and return to caller
:: 
 call currlink.bat

echo. autolink: cleaning up
 del add_link.bat
 del currlink.bat

goto end


:::::::::::::::::::::
:: err_msg section ::
:::::::::::::::::::::

:err_msg

:: ...for curious people running the batch by hand...
:: 
echo. autolink: version 1.0 - (c) Fred Pacquier - April 1998
echo. autolink: this batch file must be run by NBMC.BAT **ONLY** !


:::::::::::::::
:: at last ! ::
:::::::::::::::

:end


==============================================================================
    APPENDIX D - How to use NBMC with Microsoft Internet Explorer
==============================================================================

 When I released NBMC 2.0, I thought it would be worthwhile that people 
 using MSIE (with or without Netscape Navigator) could also benefit from 
 custom NBMC Home Pages. The problem is that both use very different ways of 
 storing bookmarks: MSIE has an entire directory structure with lots of 
 small files (one per URL), while Navigator has a single HTML file (the 
 latter being, IMHO, cleaner, simpler and less wasteful on large disks).
 At that time I found a free utility by a nice Australian chap (FTBAB) who 
 accepted readily to modify it so it could run silently as a DOS command 
 line. This way you could add just one line at the beginning of NBMC.BAT to 
 generate a Bookmark.htm in the Netscape format, and then use NBMC with an 
 otherwise 'normal" setup'. Thus, I do know for a fact that NBMC works with 
 and for MSIE.
 Unfortunately, I have had no news from the author of FTBAB in a long while, 
 and have not touched (for personal reasons) MSIE in its last versions. This 
 means I no longer can support a specific setup for MSIE users -- it's enough
 hassle having to document differences between Netscape 3 and 4 ! :-)
 If you're still interested in the MSIE/NBMC combo, however, it should be 
 fairly straightforward to achieve by following these simple hints:
 
 - if you're using both MSIE _and_ Netscape, the simplest way is to make 
   sure you only store bookmarks and create your custom Home Pages with NBMC 
   inside Netscape. Just declare NBMC.HTM as your Home Page in MSIE also, and 
   you're all set...
 
 - if you use MSIE only, you will need a utility to convert your Favorites 
   into a Netscape bookmark file. FTBAB might be ought of date, but there 
   are plenty of others, like the very nice (and free) "Columbine". Look it 
   up on NoNags (http://nng.simplenet.com/main.html). Select a directory 
   where Bookmark.htm will go, and install NBMC in a directory under that as 
   outlined above. You will also need to reproduce the equivalent steps in 
   MSIE to install NBMC as a helper application like in Netscape.
   Just remember to run the converter before using NBMC to update your Home 
   Page links, and everything should work just fine.
   
 - finally, if the above seems too much of a hassle, consider switching 
   browsers :-)
   Netscape is free now, and will improve even faster since the source code
   loose on the Internet...

==============================================================================
                                APPENDIX E - History
==============================================================================

* July 1996 - version 1.0 released to Winsite. This version used a search & 
  replace utility named FileScrub. This used to be shareware, not freeware,
  but I thought it safe to include it with NBMC because NBMC itself is 
  freeware and FileScrub had not been updated since 1987... Unfortunately
  soon afterward I found the original author on the Net and he did not agree 
  with me. So if you find old copies of NBMC 1.0 lying around (which is 
  unlikely, as it was uploaded only to one archive and not advertised), it 
  would be best to advise the maintainers of the archive to delete them or 
  update them to NBMC 2.0...
  
* August 1996 - version 2.0 is a complete rewrite using the GNU-licensed 
  GSAR package as a s&r engine. Parsing of the configuration files by GSAR 
  to produce its own output allows for much easier syntax in the user- 
  configurable sections. Also, much improved docs (wasn't hard :-).
  
* April 1998 - version 3.0 adds the one feature I most wanted -- automatic
  linking to configuration files when generating NBMC.HTM. It also adds 
  Windows NT and Navigator 3/4 support, configuration file descriptions, and
  new configuration file examples.
  Probably the last version.

* Note: I am actually quite ashamed of this last paragraph :-)
  NBMC 3.0 has been up and running since November, 1996, and it took me all 
  this time to update the docs and Web pages (a daunting task) so I could 
  have a decent package to release ! Fortunately, I have a small but 
  determined user base across the world, and some nice people have been 
  badgering and cajoling me for this update for a long while... Without 
  them, I might just have been too lazy, so thanks to the enlightened few !

==============================================================================

